/* q_r_detach - detach queue node that *pp links-in and return pointer to it */
#include "queue.h"
Q_NODE *q_r_detach(frontp, rearp, pp)
	Q_NODE **frontp, **rearp;
	Q_NODE **pp;
	{
	Q_NODE *p2;				/* ptr to detached node */

	if (*pp == NULL)
		return (NULL);
	p2 = *pp;				/* p2 points to node to detach */
	*pp = Q_NEXT(p2);		/* *pp now points to next node (or NULL) */
	if (*frontp == NULL)	/* if queue is now empty, */
		*rearp = NULL;		/* then make both ptrs NULL */
	Q_NEXT(p2) = NULL;		/* prevent dangling ptr */
	return (p2);
	}
